# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Summary:        Operations on java.lang.reflect.Type
Name:           jtype
Version:        0.1.3
Release:        1%{?dist}
Epoch:          0
Group:          Development/Framework
License:        ASL 2.0
URL:            http://code.google.com/p/jtype/
Source0:        jtype-0.1.3.tgz
# svn export http://jtype.googlecode.com/svn/tags/0.1.3/ jtype-0.1.3
# tar czf jtype-0.1.3.tgz jtype-0.1.3/

Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Patch0:         jtype-pom.patch
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Requires:       java >= 0:1.6.0
#Requires:       apache-portlet-1.0-api
#Requires:       apache-commons-collections
#Requires:       geronimo-annotation-1.1-api
#Requires:       geronimo-jaspic-1.0-api
#Requires:       glassfish-javamail141
#Requires:       jackson
#Requires:       portals-bridges1-common
#Requires:       log4j >= 0:1.2.14
#Requires:       slf4j
Requires:       geronimo-jcdi-1.0-api
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
#BuildRequires:  junit
BuildRequires:  maven2 >= 0:2.0.8
#BuildRequires:  maven-skins
#BuildRequires:  maven2-plugin-antrun
#BuildRequires:  maven2-plugin-assembly
#BuildRequires:  maven2-plugin-compiler
#BuildRequires:  maven2-plugin-eclipse
#BuildRequires:  maven2-plugin-gpg
#BuildRequires:  maven2-plugin-install
#BuildRequires:  maven2-plugin-jar
#BuildRequires:  maven2-plugin-javadoc
#BuildRequires:  maven2-plugin-project-info-reports
#BuildRequires:  maven2-plugin-remote-resources
#BuildRequires:  maven-common-artifact-filters
#BuildRequires:  maven2-plugin-resources
#BuildRequires:  maven2-plugin-site
#BuildRequires:  maven2-plugin-source
#BuildRequires:  maven2-plugin-war
#BuildRequires:  maven-archetype2
#BuildRequires:  maven-archetype2
#BuildRequires:  maven-script-interpreter
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
#BuildRequires:  maven-surefire-report-plugin
#BuildRequires:  maven-bundle-plugin
#BuildRequires:  jetty7-integration
BuildRequires:  jmock2
BuildRequires:  geronimo-jcdi-1.0-api
#BuildRequires:  mojo-clirr-maven-plugin
##BuildRequires:  yuicompressor
#BuildRequires:  yuicompressor-maven-plugin
#BuildRequires:  apache-portlet-1.0-api
#BuildRequires:  asm
#BuildRequires:  excalibur-avalon-framework
#BuildRequires:  excalibur-avalon-logkit
#BuildRequires:  cglib
#BuildRequires:  easymock-java5
#BuildRequires:  geronimo-annotation-1.1-api
#BuildRequires:  geronimo-jaspic-1.0-api
#BuildRequires:  glassfish-javamail141
#BuildRequires:  google-guice
#BuildRequires:  httpunit
#BuildRequires:  jackson
#BuildRequires:  jetty7
#BuildRequires:  apache-commons-collections
#BuildRequires:  apache-commons-httpclient
#BuildRequires:  apache-commons-lang
#BuildRequires:  apache-commons-logging
#BuildRequires:  jhighlight
#BuildRequires:  joda-time
#BuildRequires:  log4j
#BuildRequires:  portals-bridges1-common
#BuildRequires:  apache-portlet-1.0-api
#BuildRequires:  servlet_2_5_api
#BuildRequires:  slf4j
#BuildRequires:  spring3-web
#BuildRequires:  velocity14
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Java 5 introduced a richer type system for generics with Type
and its various subtypes, but lacks any easy way to perform
common operations on these types. JType aims to fill this gap.
Features
* A factory to easily create implementations of the various
  type interfaces. 
* Methods to compare and manipulate type instances, such as
  checking whether a type is a subtype of another. 
* A generic type literal that provides an equivalent of class
  literals for types. 

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
%{summary}.

%prep
%setup -q 
%patch0 -b .sav0

cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install javadoc:aggregate source:jar
#       -Dmaven.test.failure.ignore=true \
#       -Dmaven.test.skip=true \

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap com.googlecode.jtype %{name} %{version} JPP %{name}
install -m 644 target/%{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 target/%{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Mon Jan 14 2013 Ralph Apel <r.apel@r-apel.de> 0:0.1.3-1
- 0.1.3 

